Subject: bug#14051: Fwd: 24.3; Slow scrolling in term modes

From: Stefan Kangas <[email-masked]>
Date: Mon, 30 Sep 2019 18:19:25 +0200

Bryan Bishop <[email-masked]> writes:

> The window scrolling performance ("multi-term" and plain old "term" in
> this case) in emacs 24 is terrible after a few thousand lines of
> scrollback, slowly getting worse and worse and after about 5000 lines of
> scrollback takes about a 1/2 second to render the next chunk of text.
>
> How I can replicate the problem:
>
> emacs -Q
> M-x term
> find /
>
> (The output of the find command whizzes by, and then starts to get jerky
> and slow when scrollback history is > 2000 lines)
>
> I've installed the stock emacs24 from linux mint/ubuntu packages
> (24.1.1), and a custom
> compiled version of 24.3.1 without any special tricks and a compiler
> option of -O3 and the term mode behavior is all the same, and this
> behavior even shows up with "emacs -Q".
>
> It seems the same with multi-term, ansi-term, nterm, it doesn't matter.
> This does work very fast in eshell and in terminal-emulator mode.
> What is weird is ALL the terminal modes in Emacs 23 seem to work
> great, but not Emacs 24.
>
> Any ideas how I can make this mode faster?  My suspicion was around
> font-lock-mode but I've turned that off with no effect.  The fact that
> it is still slow without my init file using -Q and seems to be really
> fast in Emacs 23 has me stumped.

Yes.  Both term and ansi-term and significantly slower than eshell when
running "find /".

I had a suspicion that it was because of term-buffer-maximum-size, but
setting this to 0 made no difference.

(BTW, maybe the default term-buffer-maximum-size should be raised from
the default 2048?  For example to (* 4 2048).)

Best regards,
Stefan Kangas